osgGA::Widget Class Reference

`#include <Widget>`

Inheritance diagram for osgGA::Widget:

## Public Types

enum | FocusBehaviour { CLICK_TO_FOCUS , FOCUS_FOLLOWS_POINTER , EVENT_DRIVEN_FOCUS_DISABLED }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Widget ()
| Widget (const Widget &tfw, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgGA, Widget)
virtual void | traverse (osg::NodeVisitor &nv)
virtual void | traverseImplementation (osg::NodeVisitor &nv)
virtual bool | handle (osgGA::EventVisitor *ev, osgGA::Event *event)
virtual bool | handleImplementation (osgGA::EventVisitor *ev, osgGA::Event *event)
virtual bool | computePositionInLocalCoordinates (osgGA::EventVisitor *ev, osgGA::GUIEventAdapter *event, osg::Vec3 &localPosition) const
virtual void | createGraphics ()
virtual void | createGraphicsImplementation ()
virtual void | setExtents (const osg::BoundingBoxf &bb)
const osg::BoundingBoxf & | getExtents () const
void | setFocusBehaviour (FocusBehaviour behaviour)
FocusBehaviour | getFocusBehaviour () const
virtual void | updateFocus (osg::NodeVisitor &nv)
virtual void | setHasEventFocus (bool focus)
virtual bool | getHasEventFocus () const
virtual osg::BoundingSphere | computeBound () const
virtual void | enter ()
virtual void | enterImplementation ()
virtual void | leave ()
virtual void | leaveImplementation ()
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Widget ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

FocusBehaviour | _focusBehaviour
bool | _hasEventFocus
bool | _graphicsInitialized
osg::BoundingBoxf | _extents
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Enumeration Documentation

## FocusBehaviour

enum osgGA::Widget::FocusBehaviour

Enumerator
CLICK_TO_FOCUS |
FOCUS_FOLLOWS_POINTER |
EVENT_DRIVEN_FOCUS_DISABLED |

## Constructor & Destructor Documentation

## Widget() [1/2]

osgGA::Widget::Widget | ( |  | ) |

Referenced by META_Node(), and Widget().

## Widget() [2/2]

osgGA::Widget::Widget | ( | const Widget & | tfw,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and Widget().

## ~Widget()

virtual osgGA::Widget::~Widget | ( |  | ) |

inline protected virtual

## Member Function Documentation

## computeBound()

virtual osg::BoundingSphere osgGA::Widget::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

## computePositionInLocalCoordinates()

virtual bool osgGA::Widget::computePositionInLocalCoordinates | ( | osgGA::EventVisitor * | ev,
|  | osgGA::GUIEventAdapter * | event,
|  | osg::Vec3 & | localPosition ) const

virtual

## createGraphics()

virtual void osgGA::Widget::createGraphics | ( |  | ) |

virtual

## createGraphicsImplementation()

virtual void osgGA::Widget::createGraphicsImplementation | ( |  | ) |

virtual

## enter()

virtual void osgGA::Widget::enter | ( |  | ) |

virtual

update any focus related graphics+state to the focused state.

## enterImplementation()

virtual void osgGA::Widget::enterImplementation | ( |  | ) |

virtual

## getExtents()

const osg::BoundingBoxf & osgGA::Widget::getExtents | ( |  | ) | const

inline

References _extents.

## getFocusBehaviour()

FocusBehaviour osgGA::Widget::getFocusBehaviour | ( |  | ) | const

inline

References _focusBehaviour.

## getHasEventFocus()

virtual bool osgGA::Widget::getHasEventFocus | ( |  | ) | const

virtual

get whether the widget has focus or not.

## handle()

virtual bool osgGA::Widget::handle | ( | osgGA::EventVisitor * | ev,
|  | osgGA::Event * | event )

virtual

## handleImplementation()

virtual bool osgGA::Widget::handleImplementation | ( | osgGA::EventVisitor * | ev,
|  | osgGA::Event * | event )

virtual

## leave()

virtual void osgGA::Widget::leave | ( |  | ) |

virtual

update any focus related graphics+state to the unfocused state.

## leaveImplementation()

virtual void osgGA::Widget::leaveImplementation | ( |  | ) |

virtual

## META_Node()

osgGA::Widget::META_Node | ( | osgGA | ,
|  | Widget | )

References Widget().

## setExtents()

virtual void osgGA::Widget::setExtents | ( | const osg::BoundingBoxf & | bb | ) |

virtual

## setFocusBehaviour()

void osgGA::Widget::setFocusBehaviour | ( | FocusBehaviour | behaviour | ) |

inline

References _focusBehaviour.

## setHasEventFocus()

virtual void osgGA::Widget::setHasEventFocus | ( | bool | focus | ) |

virtual

set whether the widget has focus or not.

## traverse()

virtual void osgGA::Widget::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Group.

## traverseImplementation()

virtual void osgGA::Widget::traverseImplementation | ( | osg::NodeVisitor & | nv | ) |

virtual

## updateFocus()

virtual void osgGA::Widget::updateFocus | ( | osg::NodeVisitor & | nv | ) |

virtual

update the focus according to events.

## Member Data Documentation

## _extents

osg::BoundingBoxf osgGA::Widget::_extents

protected

Referenced by getExtents().

## _focusBehaviour

FocusBehaviour osgGA::Widget::_focusBehaviour

protected

Referenced by getFocusBehaviour(), and setFocusBehaviour().

## _graphicsInitialized

bool osgGA::Widget::_graphicsInitialized

protected

## _hasEventFocus

bool osgGA::Widget::_hasEventFocus

protected

The documentation for this class was generated from the following file:

- osgGA/Widget